#
# This is the SPEC file for creating binary and source RPMs for the Dom0.
#
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

Name:		qubes-gui-daemon
Version:	4.2.6
Release:	1%{dist}
Summary:	The Qubes GUI virtualization

Group:		Qubes
Vendor:		Invisible Things Lab
License:	GPL
URL:		http://www.qubes-os.org

Requires:	xorg-x11-server-Xorg
Requires:	service(graphical-login)
Requires:	libconfig
Requires:	python%{python3_pkgversion}-xcffib
Requires:	qubes-utils >= 4.2.10
Requires:	qubes-core-qrexec >= 4.1.5
Requires:	python%{python3_pkgversion}-qubesimgconverter >= 4.1.4
Requires:	socat
Requires:	group(qubes)

BuildRequires:	python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-setuptools
BuildRequires:	pulseaudio-libs-devel
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(x11-xcb)
BuildRequires:	pkgconfig(xcb)
BuildRequires:	pkgconfig(xcb-aux)
BuildRequires:	pkgconfig(xcb-shm)
BuildRequires:	libXrandr-devel
BuildRequires:	libconfig-devel
BuildRequires:	libpng-devel
BuildRequires:	libnotify-devel
BuildRequires:	xen-devel
BuildRequires:	qubes-db-devel
BuildRequires:	help2man
BuildRequires:	gcc
BuildRequires:	qubes-core-libs-devel >= 1.6.1
BuildRequires:	qubes-core-libs
BuildRequires:	qubes-gui-common-devel >= 3.2.0
BuildRequires:	qubes-libvchan-xen-devel
BuildRequires:	qubes-utils-devel >= 4.2.10

Source0: %{name}-%{version}.tar.gz

%description
The Qubes GUI virtualization infrastructure that needs to be installed in GuiVM.

%package -n qubes-gui-dom0
Summary:    Dom0 part of Qubes GUI
# For now require also gui-daemon in dom0, when dropping GUI in dom0, this
# dependency should be dropped
Requires:   qubes-gui-daemon
# Pull also audio packages for easier upgrade
Requires:   qubes-audio-daemon
Requires:   qubes-audio-dom0
Requires:	qubes-core-dom0 >= 4.1.1
# for policy.EvalSimple service
Requires:	qubes-core-qrexec-dom0 >= 4.1.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-gui-dom0
Dom0 files for Qubes GUI virtualization. This include core-admin extension,
policy files etc.

%package -n qubes-audio-daemon
Summary:	The Qubes AUDIO virtualization
Requires:	pulseaudio-libs
%if 0%{?fedora} >= 35
Requires:	pulseaudio-daemon
%else
Requires:	pulseaudio
%endif
Requires:	libconfig
Requires:   qubes-utils >= 3.1.0
Requires:   python%{python3_pkgversion}-pydbus

%description -n qubes-audio-daemon
The Qubes AUDIO virtualization infrastructure that needs to be installed in AudioVM.

%package -n qubes-audio-dom0
Summary:    Dom0 part of Qubes AUDIO
Requires:	qubes-core-dom0 >= 1.3.14
Requires:   python%{python3_pkgversion}-setuptools

%description -n qubes-audio-dom0
Dom0 files for Qubes AUDIO virtualization. This include core-admin extension,
policy files etc.

%prep
%setup -q

%build
%{?set_build_flags}
make clean
make all BACKEND_VMM=xen

%py3_build

%pre

%install
rm -rf $RPM_BUILD_ROOT
%make_install
%py3_install

%triggerin -- xorg-x11-server-Xorg
ln -sf /usr/bin/X-wrapper-qubes /usr/bin/X

%postun
if [ "$1" = 0 ] ; then
	# no more packages left
    ln -sf /usr/bin/Xorg /usr/bin/X
fi

%clean
rm -rf $RPM_BUILD_ROOT
rm -f %{name}-%{version}

%files
%defattr(-,root,root,-)
%attr(4750,root,qubes) /usr/bin/qubes-guid
%{_mandir}/man1/qubes-guid.1.gz
/usr/bin/X-wrapper-qubes
%{_libdir}/qubes-gui-daemon/shmoverride.so
%config(noreplace) %{_sysconfdir}/qubes/guid.conf
/etc/xdg/autostart/qubes-screen-layout-watches.desktop
/etc/xdg/autostart/qubes-icon-receiver.desktop
/etc/X11/xinit/xinitrc.d/qubes-localgroup.sh
/usr/libexec/qubes/watch-screen-layout-changes
/usr/lib/qubes/icon-receiver
%config %{_sysconfdir}/qubes-rpc/qubes.WindowIconUpdater
%config %{_sysconfdir}/qubes/rpc-config/qubes.WindowIconUpdater

%files -n qubes-audio-daemon
/usr/bin/pacat-simple-vchan
/etc/qubes-rpc/qubes.AudioInputEnable
/etc/qubes-rpc/qubes.AudioInputDisable

%files -n qubes-gui-dom0
%config(noreplace) %{_sysconfdir}/qubes/policy.d/90-default-gui-daemon.policy

%files -n qubes-audio-dom0
%{python3_sitelib}/qubesguidaemon-*.egg-info
%{python3_sitelib}/qubesguidaemon

%changelog
* Fri Apr 05 2024 Qubes OS Team <qubes-devel@googlegroups.com>
- For complete changelog see: https://github.com/QubesOS/qubes-gui-daemon

* Fri Apr 05 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 6583783
- version 4.2.6

* Sat Feb 24 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 0be59e2
- pulse: make tlength parameter configurable, reduce fragsize

* Sat Feb 24 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 68a5dba
- pulse: add opt-in debug logging

* Thu Feb 22 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 8874142
- pulse: add timestamps to log output

* Mon Feb 05 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 9029d0e
- version 4.2.5

* Mon Feb 05 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b99da5a
- shmoverride: fix parameters order

* Thu Jan 25 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - 9795a4e
- Always block on vchan I/O by default

* Thu Jan 11 2024 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 599e593
- version 4.2.4

* Wed Jan 03 2024 Demi Marie Obenour <demi@invisiblethingslab.com> - d1826fb
- Do not crash if the work area is invalid

* Mon Sep 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9584e3f
- Allow periods in qube names

* Fri Sep 15 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 1ba8051
- Revert "Allow periods in qube names"

* Sun Aug 20 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - a8f61fe
- Allow periods in qube names

* Mon Aug 14 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 4bf3a93
- Clean up do_shm_update

* Thu Apr 27 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - adadf48
- version 4.2.3

* Sat Apr 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0a255d9
- Allow selecting blocking or non-blocking I/O

* Sat Apr 15 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e54de11
- Do not cork a playback stream with nonempty buffers

* Thu Apr 13 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 0fbcb05
- Drain playback stream before corking it

* Sat Mar 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 811a31a
- Ensure notifications conform to header-body format

* Sat Mar 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5bc9a32
- Do not send MSG_DESTROY to agents that aren't expecting it

* Sat Mar 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - bd38763
- Avoid hard-coding protocol versions

* Sat Mar 18 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - ce984fb
- ACK all grant mappings

* Fri Feb 03 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - d815f91
- version 4.2.2

* Thu Feb 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f10c50e
- Use new qrexec policy format

* Thu Feb 02 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - e413294
- rpm: fix files ownership on install

* Thu Jan 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 180f8de
- Strictly validate message lengths

* Thu Jan 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - be2d345
- Earlier validation of MSG_WINDOW_DUMP sizes

* Thu Jan 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5de8e14
- Do not use VERIFY with partially-read messages

* Thu Jan 12 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 9e0b82d
- Do not read a message unless a header is ready

* Mon Jan 09 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - 5d4a4d2
- Fix a typo in a comment

* Mon Jan 09 2023 Demi Marie Obenour <demi@invisiblethingslab.com> - e3dac04
- do_shm_update: Negative width or height is an error

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - b40c15a
- version 4.2.1

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 35c8b57
- ci: drop R4.1

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - f136d83
- rpm: drop explicit libvchan dependency

* Mon Jan 09 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 81c0832
- Deal with delayed pulseaudio agent startup

* Wed Jan 04 2023 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - efa9c89
- pulse: Fix indentation

* Fri Dec 02 2022 Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com> - 328b628
- version 4.2.0

* Sun Oct 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ca28b9d
- Remove unneeded header includes

* Sun Oct 30 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 6c1763d
- Fix some -Wconversion warnings

* Sun Oct 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 9ac7897
- Rip out subwindows support

* Sun Oct 16 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 12f7d0d
- Fix function prototype mismatches and use poll(2)

* Sat Oct 15 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - ac63f20
- Clean up some macros

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2b58ea2
- Do not check for WM_STATE changes on the root window

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - eab7a7a
- Add assertions and comments in do_shm_update

* Fri Oct 14 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 32df049
- Make the build system a bit better

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a051283
- Better logging and command-line parsing

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 2a81ce2
- Remove remaining use of System V shared memory

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - 32a591b
- shmoverride: avoid keeping state for munmap

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - a7c1751
- Use FD passing for shared memory

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - e08744c
- Update shmoverride/README for Xlib → xcb change

* Thu Oct 13 2022 Demi Marie Obenour <demi@invisiblethingslab.com> - b266385
- Switch from Xlib to XCB for shared memory

